/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.circletask.PAutoAddCircleTask
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.mission.PAcceptMajorMission
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.TeamManager
 *  fire.pb.triggers.event.TriggerEvent
 *  mkdb.Procedure
 *  mkdb.Trace
 *  xbean.Pod
 *  xbean.TriggerRole
 *  xtable.Properties
 *  xtable.Triggerroles
 */
package fire.pb.triggers;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.activity.award.RewardMgr;
import fire.pb.circletask.PAutoAddCircleTask;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.mission.PAcceptMajorMission;
import fire.pb.talk.MessageMgr;
import fire.pb.team.TeamManager;
import fire.pb.triggers.Module;
import fire.pb.triggers.event.TriggerEvent;
import java.util.List;
import java.util.Set;
import mkdb.Procedure;
import mkdb.Trace;
import xbean.Pod;
import xtable.Properties;
import xtable.Triggerroles;

public class TriggerRole {
    private long roleId;
    private xbean.TriggerRole triggerbean;

    public long getRoleid() {
        return this.roleId;
    }

    public TriggerRole(long roleId, boolean readonly) {
        this.roleId = roleId;
        this.triggerbean = readonly ? Triggerroles.select((Long)roleId) : Triggerroles.get((Long)roleId);
        if (this.triggerbean == null) {
            if (readonly) {
                this.triggerbean = Pod.newTriggerRoleData();
            } else {
                this.triggerbean = Pod.newTriggerRole();
                Triggerroles.insert((Long)roleId, (xbean.TriggerRole)this.triggerbean);
            }
        }
    }

    public boolean isTriggered(int triggerId) {
        return this.triggerbean.getTriggeredids().contains(triggerId);
    }

    public void trigger4taskcom(int taskid) {
        Set<Integer> temp = Module.getInstance().getTriggerIdByTaskId(taskid);
        if (temp != null && temp.size() > 0) {
            for (Integer triggerid : temp) {
                Trace.debug((Object)("taskid:" + taskid + "完成！手动触发:" + triggerid));
                this.triggerbean.getTriggeredids().add(triggerid);
            }
        }
    }

    public boolean trigger(int triggerId) {
        if (this.isTriggered(triggerId)) {
            return false;
        }
        TriggerEvent triggerevent = Module.getInstance().getTriggerEvents().get(triggerId);
        if (triggerevent == null) {
            return false;
        }
        if (!this.valid(triggerevent)) {
            return false;
        }
        this.sendMsg(triggerevent);
        this.reward(triggerevent);
        this.removeQuest(triggerevent);
        this.addQuest(triggerevent);
        this.triggerbean.getTriggeredids().add(triggerId);
        return true;
    }

    public int getTriggerByType(int triggerType, List<Integer> args) {
        int triggered = 0;
        for (TriggerEvent triggerevent : Module.getInstance().getTriggerEvents().values()) {
            if (triggerevent.type != triggerType || this.isTriggered(triggerevent.id) || !this.valid(triggerevent) || !triggerevent.triggered(this, args)) continue;
            triggered = triggerevent.id;
            break;
        }
        return triggered;
    }

    public boolean triggerByType(int triggerType, List<Integer> args) {
        int triggered = this.getTriggerByType(triggerType, args);
        if (triggered == 0) {
            return false;
        }
        return this.trigger(triggered);
    }

    public void triggersByType(int triggerType, List<Integer> args) {
        for (TriggerEvent triggerevent : Module.getInstance().getTriggerEvents().values()) {
            if (triggerevent == null || triggerevent.type != triggerType || this.isTriggered(triggerevent.id) || !this.valid(triggerevent) || !triggerevent.triggered(this, args)) continue;
            Trace.debug((Object)("triggered:" + triggerevent.id));
            this.sendMsg(triggerevent);
            this.reward(triggerevent);
            this.removeQuest(triggerevent);
            this.addQuest(triggerevent);
            this.triggerbean.getTriggeredids().add(triggerevent.id);
        }
    }

    public boolean inRegion(int regionId) {
        Role role = RoleManager.getInstance().getRoleByID(this.roleId);
        return role.isInRegion(regionId);
    }

    public boolean valid(TriggerEvent triggerevent) {
        int level = Properties.selectLevel((Long)this.roleId);
        if (level < triggerevent.needlevel) {
            return false;
        }
        if (triggerevent.needquest != 0) {
            // empty if block
        }
        triggerevent.getClass();
        return true;
    }

    private void sendMsg(TriggerEvent event) {
        if (event.msgId == 0) {
            return;
        }
        MessageMgr.sendMsgNotify((long)this.roleId, (int)event.msgId, null);
    }

    private void reward(TriggerEvent event) {
        if (event.rewardId == 0) {
            return;
        }
        RewardMgr.getInstance().distributeAllAward(this.roleId, event.rewardId, null, YYLoggerTuJingEnum.GENERAL, event.rewardId, 4003, "trigger");
    }

    private void removeQuest(TriggerEvent event) {
        if (event.removequest == 0) {
            return;
        }
    }

    private void addQuest(final TriggerEvent event) {
        if (event.addquest == 0) {
            return;
        }
        Procedure.pexecuteWhileCommit((Procedure)new Procedure(){

            protected boolean process() {
                TeamManager.getTeamByRoleId((long)TriggerRole.this.roleId);
                if (event.addquest < 1000000) {
                    new PAcceptMajorMission(TriggerRole.this.roleId, event.addquest, true, true).call();
                } else {
                    new PAutoAddCircleTask(TriggerRole.this.roleId, event.addquest).call();
                }
                return true;
            }
        });
    }
}

